/**************************

  Claude Shannon's
   Ultimate Machine

  (c) Andi Kanzler 2010

***************************/

#include <avr/io.h>
#include <util/delay.h>
#include "servo.h"

#define SWITCH (PINB & (1 << PINB0))

int main(void)
{
    DDRD |= ((1 << PD6) | (1 << PD7)); // Ausg
    PORTD = 0; // Keine Pullups
    DDRB |= ((0 << PB0) | (1 << PB1)); // PB0 Eingang, PB1 Ausgang
    PORTB |= (1 << PB0); // Pullup fr PB0

    init_servos();
    _delay_ms(50);

    // Relias ein, um Stromzufuhr zu erhalten
    PORTB |= (1 << PB1);

    do
    {
        // Deckel ffnen
        setservo(1, 200);
        uint8_t i = 0;
        do
        {
             _delay_ms(50);
             i++;
        }
        while ((!SWITCH) && (i < 3));

        // Arm aus- und wieder einfahren
        if (!SWITCH)
        {
            do
            {
                setservo(0, 107);
                do
                    _delay_ms(50);
                while (!SWITCH);

                setservo(0, 250);
                i = 0;
                do
                {
                    _delay_ms(50);
                    i++;
                }
                while (SWITCH && (i < 4));
            }
            while (!SWITCH);
        }

        // Deckel schliessen
        i = 0;
        setservo(1, 60);
        do
        {
            _delay_ms(50);
            i++;
        }
        while ((SWITCH) && (i < 8));
    }
    while (!SWITCH);

    // Relais aus (Stromversorung kappen)
    PORTB &= (0 << PB1);

    return 0;
}
