/************************************************************************

   SERVO Controller for up to 10 Servos

   controlled by serial line
   default: 2400 Baud 8N1

   Processor: ATMEGA 8
   CLOCK: 8MHZ, no prescaler set config bits of Atmega 8 correctly !

   Compiler: AVR-GCC


   This code is licensed under the GPL.
   You may modify, redistribute the code .. blabla, you know what I mean ...

   Copyright stochri (c.hab@gmx.net) Nov.2005

   -----
   Modified by Andi Kanzler (andi_kanzler@gmx.de), Mar. 2010

***************************************************************************/

#ifndef SERVO_H
#define SERVO_H

#include <stdlib.h>
#include <inttypes.h>
#include <avr/interrupt.h>

#define SYSCLK 4000000 // timer clock 4Mhz
#define MAXVALUE 240 // Max. Servo value
#define MINVALUE 10  // Min. Servo value
#define STARTVALUES {250, 60, 128, 128, 128, 128, 128, 128, 128, 128} // Startvalues for the Servos 0-9

// port pin definitions
// you may redefine the pins to suit your application
// take a look at the interrupt routine and enable the cases for your servo

#define LOW_SERVO0 PORTD &= ~(1 << PD6)
#define HIGH_SERVO0 PORTD |= (1 << PD6)

#define LOW_SERVO1 PORTD &= ~(1 << PD7)
#define HIGH_SERVO1 PORTD |= (1 << PD7)

#define LOW_SERVO2
#define HIGH_SERVO2

#define LOW_SERVO3
#define HIGH_SERVO3

#define LOW_SERVO4
#define HIGH_SERVO4

#define LOW_SERVO5
#define HIGH_SERVO5

#define LOW_SERVO6
#define HIGH_SERVO6

#define LOW_SERVO7
#define HIGH_SERVO7

#define LOW_SERVO8
#define HIGH_SERVO8

#define LOW_SERVO9
#define HIGH_SERVO9


extern void setservo(uint8_t index, uint8_t value);

extern void init_servos();

#endif // SERVO_H

